<!--
  Copyright (c) 2017 Qualcomm Technologies, Inc.
  All Rights Reserved.
  Confidential and Proprietary - Qualcomm Technologies, Inc.
-->
<!--
CameraModuleConfig :
    This node must be added for each module prosent in the device.
    It contain all information about the module present.
    The number of nodes of CameraModuleConfig indicate number of modules
    to be probed on the device.
    Maximum number of CameraModuleConfig nodes is 10
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*CameraId :
    Camera Id is the Slot number in which the mode is plugged.
    Valid values are 0, 1, 2 and 3.
*SensorName :
    Name of the sensor present on the module.
    The sensor library name should be of the form libmmcamera_<SensorName>.so
ActuatorName :
    Name of the actuator on this module.
    The actuator library name should be of the form libactuator_<ActuatorName>.so.
    If there is no actuator remove the <ActuatorName> node.
EepromName :
    Name of the eeprom on this module.
    Eeprom lib name should be of the form libmmcamera_<EepromName>_eeprom.so
    If there is no eeprom remove the <EepromName> node.
FlashName :
    Name of the flash on this module.
    The flash library name should be of the form libflash_<FlashName>.so.
    If there is no flash remove the <FlashName> node.
ChromatixName :
    Name of the tuning xml file.
    Tuning file contains the list of chromatix library names.
    If there is no tuning xml file remove the <ChromatixName> node.
Position :
    Position of the sensor module. Valid values are:
    BACK, FRONT, BACK_AUX and FRONT_AUX
MountAngle :
    Angle at which the sensor is mounted. Valid values are 0, 90, 180, 270 and 360.
    To use default mountangle mentioned in kernel use 360.

CsiInfo : This node contains information about the receiver configuration.
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

*CSIDCore :
    CSID core to receive the data. Valid values are 0, 1, 2 and 3.
*LaneMask :
    Mask to mention which lane is enabled.
    LaneMask[0] for DL0.
    LaneMask[1] for CLK.
    LaneMask[2] for DL1.
    LaneMask[3] for DL2.
    LaneMask[4] for DL3
*LaneAssign :
    Number which describes the lane mapping between sensor and PHY.
    LaneAssign[0:3] is sensor lane number connected to data lane 0 of PHY on MSM
    LaneAssign[4:7] is sensor lane number connected to data lane 2 of PHY on MSM
    LaneAssign[8:11] is sensor lane number connected to data lane 3 of PHY on MSM
    LaneAssign[12:15] is sensor lane number connected to data lane 4 of PHY on MSM

    NOTE : Lane 1 is reserved for the clock lane.
        Wiring and setting it to a data lane is prohibited.
ComboMode :
    Flag to enable combo mode.
    This flag is enabled if multiple sensors are using same CSI-PHY receiver

LensInfo : Information of the lens present in the module.
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
LensType :
    Type of the lens.
    Valid values are NORMAL, WIDE, TELE.
*FocalLength :
    FocalLength of the lens in micometers.
    Distance between the center of curvature to the focal point.
*FNumber :
    FNumber of the lens.
*TotalFocusDistance : The total distance in meters the lens could focus.
*HorizontalViewAngle : HorizontalViewAngle in degrees
*VerticalViewAngle : VerticalViewAngle in degrees
*MinFocusDistance : Minimum distance in meters the lens could focus.
 MinRollDegree : Maximum degree of rotation along X axis of
                 tele sensor with respect to the wide sensor.
 MinPitchDegree : Maximum degree of rotation along Y axis of
                  tele sensor with respect to the wide sensor.
 MinYawDegree : Maximum degree of rotation along Z axis of
                tele sensor with respect to the wide sensor.

*VARIABLES MARKED WITH ASTRICK (*) ARE MANDATORY.

-->

<CameraConfigurationRoot>

  <!-- Auvidea_b102 in camera slot 0 -->
  <CameraModuleConfig>
    <CameraId>0</CameraId>
    <SensorName>auvidea_b102</SensorName>
    <I2CFrequencyMode>FAST</I2CFrequencyMode>
    <ChromatixName>ov7251_chromatix</ChromatixName>
    <ModesSupported>1</ModesSupported>
    <Position>BACK</Position>
    <MountAngle>360</MountAngle>
    <CSIInfo>
      <CSIDCore>0</CSIDCore>
      <LaneMask>0x1F</LaneMask>
      <LaneAssign>0x4320</LaneAssign>
      <ComboMode>0</ComboMode>
    </CSIInfo>
    <LensInfo>
      <FocalLength>4.73</FocalLength>
      <FNumber>2.2</FNumber>
      <TotalFocusDistance>1.9</TotalFocusDistance>
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>
      <MinFocusDistance>0.1</MinFocusDistance>
    </LensInfo>
  </CameraModuleConfig>

  <!-- IMX377 in camera slot 0 -->
  <CameraModuleConfig>
    <CameraId>0</CameraId>
    <SensorName>imx377</SensorName>
    <ChromatixName>imx377_chromatix</ChromatixName>
    <ModesSupported>1</ModesSupported>
    <Position>BACK</Position>
    <MountAngle>360</MountAngle>
    <CSIInfo>
      <CSIDCore>0</CSIDCore>
      <LaneMask>0x1F</LaneMask>
      <LaneAssign>0x4320</LaneAssign>
      <ComboMode>0</ComboMode>
    </CSIInfo>
    <LensInfo>
      <FocalLength>4.73</FocalLength>
      <FNumber>2.2</FNumber>
      <TotalFocusDistance>1.9</TotalFocusDistance>
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>
      <MinFocusDistance>0.1</MinFocusDistance>
    </LensInfo>
  </CameraModuleConfig>

  <!-- IMX377 in camera slot 1 -->                                                
  <CameraModuleConfig>       
    <CameraId>1</CameraId>                       
    <SensorName>imx377</SensorName>                                          
    <ChromatixName>imx377_chromatix</ChromatixName>
    <ModesSupported>1</ModesSupported>                                            
    <Position>BACK</Position>                              
    <MountAngle>360</MountAngle>                         
    <CSIInfo>                                                                  
      <CSIDCore>1</CSIDCore>                                                
      <LaneMask>0x1F</LaneMask>                        
      <LaneAssign>0x4320</LaneAssign>             
      <ComboMode>0</ComboMode>                       
    </CSIInfo>                                                           
    <LensInfo>                                                  
      <FocalLength>4.73</FocalLength>
      <FNumber>2.2</FNumber>    
      <TotalFocusDistance>1.9</TotalFocusDistance>                      
      <HorizontalViewAngle>64.1</HorizontalViewAngle>              
      <VerticalViewAngle>51.6</VerticalViewAngle>
      <MinFocusDistance>0.1</MinFocusDistance>                      
    </LensInfo>                                            
  </CameraModuleConfig>

  <!-- TOF in camera slot 0 -->
  <CameraModuleConfig>
    <CameraId>0</CameraId>
    <SensorName>irs10x0c</SensorName>
    <ChromatixName>ov7251_chromatix</ChromatixName>
    <ModesSupported>1</ModesSupported>
    <I2CFrequencyMode>FAST</I2CFrequencyMode>
    <Position>FRONT</Position>
    <MountAngle>360</MountAngle>
    <CSIInfo>
      <CSIDCore>0</CSIDCore>
      <LaneMask>0x1F</LaneMask>
      <LaneAssign>0x4320</LaneAssign>
      <ComboMode>0</ComboMode>
    </CSIInfo>
    <LensInfo>
      <FocalLength>4.73</FocalLength>
      <FNumber>2.2</FNumber>
      <TotalFocusDistance>1.9</TotalFocusDistance>
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>
      <MinFocusDistance>0.1</MinFocusDistance>
    </LensInfo>
  </CameraModuleConfig>
  
  <!-- TOF in camera slot 1 -->
  <CameraModuleConfig>
    <CameraId>1</CameraId>
    <SensorName>irs10x0c</SensorName>
    <ChromatixName>ov7251_chromatix</ChromatixName>
    <ModesSupported>1</ModesSupported>
    <I2CFrequencyMode>FAST</I2CFrequencyMode>
    <Position>FRONT</Position>
    <MountAngle>360</MountAngle>
    <CSIInfo>
      <CSIDCore>1</CSIDCore>
      <LaneMask>0x1F</LaneMask>
      <LaneAssign>0x4320</LaneAssign>
      <ComboMode>0</ComboMode>
    </CSIInfo>
    <LensInfo>
      <FocalLength>4.73</FocalLength>
      <FNumber>2.2</FNumber>
      <TotalFocusDistance>1.9</TotalFocusDistance>
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>
      <MinFocusDistance>0.1</MinFocusDistance>
    </LensInfo>
  </CameraModuleConfig>

  <!-- TOF in camera slot 2 -->                      
  <CameraModuleConfig>                               
    <CameraId>2</CameraId>                                                     
    <SensorName>irs10x0c</SensorName>                                           
    <ChromatixName>ov7251_chromatix</ChromatixName>                             
    <ModesSupported>1</ModesSupported>                                           
    <I2CFrequencyMode>FAST</I2CFrequencyMode>                                     
    <Position>FRONT</Position>                       
    <MountAngle>360</MountAngle>                     
    <CSIInfo>                                                                
      <CSIDCore>2</CSIDCore>                         
      <LaneMask>0x1F</LaneMask>                      
      <LaneAssign>0x4320</LaneAssign>                                             
      <ComboMode>0</ComboMode>                             
    </CSIInfo>                                           
    <LensInfo>                                                                 
      <FocalLength>4.73</FocalLength>                                       
      <FNumber>2.2</FNumber>                           
      <TotalFocusDistance>1.9</TotalFocusDistance>   
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>                        
      <MinFocusDistance>0.1</MinFocusDistance>                  
    </LensInfo>                                      
  </CameraModuleConfig> 

  <!-- IMX214 in camera slot 0 -->
  <CameraModuleConfig>
    <CameraId>0</CameraId>
    <SensorName>imx214_rot180</SensorName>
    <ChromatixName>imx214_chromatix</ChromatixName>
    <I2CFrequencyMode>FAST</I2CFrequencyMode>
    <ModesSupported>1</ModesSupported>
    <Position>BACK</Position>
    <MountAngle>360</MountAngle>
    <CSIInfo>
      <CSIDCore>0</CSIDCore>
      <LaneMask>0x1F</LaneMask>
      <LaneAssign>0x4320</LaneAssign>
      <ComboMode>0</ComboMode>
    </CSIInfo>
    <LensInfo>
      <FocalLength>4.73</FocalLength>
      <FNumber>2.2</FNumber>
      <TotalFocusDistance>1.9</TotalFocusDistance>
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>
      <MinFocusDistance>0.1</MinFocusDistance>
    </LensInfo>
  </CameraModuleConfig>

  <!-- IMX214 in camera slot 1 -->                                               
  <CameraModuleConfig>                                                            
    <CameraId>1</CameraId>                       
    <SensorName>imx214_rot180</SensorName>       
    <ChromatixName>imx214_chromatix</ChromatixName>
    <I2CFrequencyMode>FAST</I2CFrequencyMode>      
    <ModesSupported>1</ModesSupported>                                        
    <Position>BACK</Position>                          
    <MountAngle>360</MountAngle>                     
    <CSIInfo>                                                              
      <CSIDCore>1</CSIDCore>                                            
      <LaneMask>0x1F</LaneMask>                    
      <LaneAssign>0x4320</LaneAssign>              
      <ComboMode>0</ComboMode>                     
    </CSIInfo>                                                       
    <LensInfo>                                              
      <FocalLength>4.73</FocalLength>              
      <FNumber>2.2</FNumber>                       
      <TotalFocusDistance>1.9</TotalFocusDistance>                  
      <HorizontalViewAngle>64.1</HorizontalViewAngle>          
      <VerticalViewAngle>51.6</VerticalViewAngle>    
      <MinFocusDistance>0.1</MinFocusDistance>                  
    </LensInfo>                                        
  </CameraModuleConfig> 

  <!-- ov7251 tracking camera in camera slot 2 -->
  <CameraModuleConfig>
    <CameraId>2</CameraId>
    <SensorName>ov7251_tracking</SensorName>
    <SensorSlaveAddress>0xE0</SensorSlaveAddress>
    <ChromatixName>ov7251_chromatix</ChromatixName>
    <ModesSupported>1</ModesSupported>
    <Position>FRONT</Position>
    <MountAngle>360</MountAngle>
    <CSIInfo>
      <CSIDCore>2</CSIDCore>
      <LaneMask>0x1F</LaneMask>
      <LaneAssign>0x4320</LaneAssign>
      <ComboMode>0</ComboMode>
    </CSIInfo>
    <LensInfo>
      <FocalLength>4.73</FocalLength>
      <FNumber>2.2</FNumber>
      <TotalFocusDistance>1.9</TotalFocusDistance>
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>
      <MinFocusDistance>0.1</MinFocusDistance>
    </LensInfo>
  </CameraModuleConfig>
  <CameraModuleConfig>                              
    <CameraId>0</CameraId>                                                     
    <SensorName>ov9282</SensorName>                                         
    <SensorSlaveAddress>0x20</SensorSlaveAddress>
    <ChromatixName>ov9282_chromatix</ChromatixName>           
    <ModesSupported>1</ModesSupported>                                         
    <Position>BACK</Position>
    <MountAngle>360</MountAngle>             
    <CSIInfo>                                                                
      <CSIDCore>0</CSIDCore>
      <LaneMask>0x7</LaneMask>            
      <LaneAssign>0x20</LaneAssign>                                               
      <ComboMode>0</ComboMode>                             
    </CSIInfo>          
    <LensInfo>                                                          
      <FocalLength>4.73</FocalLength>                                       
      <FNumber>2.2</FNumber>                           
      <TotalFocusDistance>1.9</TotalFocusDistance>                  
      <HorizontalViewAngle>64.1</HorizontalViewAngle>      
      <VerticalViewAngle>51.6</VerticalViewAngle>                        
      <MinFocusDistance>0.1</MinFocusDistance>              
    </LensInfo>                                               
  </CameraModuleConfig>

  <!-- ov7251 stereo pair in camera slot 1 -->
  <!-- ov7251 stereo can only work in slot 1 -->
  <StereoConfig>
    <SensorNode>
      <CameraId>1</CameraId>
      <SensorName>ov7251_stereo</SensorName>
      <SensorSlaveAddress>0xC0</SensorSlaveAddress>
      <ChromatixName>ov7251_chromatix</ChromatixName>
      <ModesSupported>1</ModesSupported>
      <Position>FRONT</Position>
      <MountAngle>360</MountAngle>
      <CSIInfo>
        <CSIDCore>1</CSIDCore>
        <LaneMask>0x3</LaneMask>
        <LaneAssign>0x0</LaneAssign>
        <ComboMode>1</ComboMode>
      </CSIInfo>
      <LensInfo>
        <FocalLength>4.73</FocalLength>
        <FNumber>2.2</FNumber>
        <TotalFocusDistance>1.9</TotalFocusDistance>
        <HorizontalViewAngle>64.1</HorizontalViewAngle>
        <VerticalViewAngle>51.6</VerticalViewAngle>
        <MinFocusDistance>0.1</MinFocusDistance>
      </LensInfo>
    </SensorNode>
    <SensorNode>
      <CameraId>3</CameraId>
      <SensorName>ov7251_stereo</SensorName>
      <ChromatixName>ov7251_chromatix</ChromatixName>
      <ModesSupported>1</ModesSupported>
      <Position>FRONT</Position>
      <MountAngle>360</MountAngle>
      <CSIInfo>
        <CSIDCore>3</CSIDCore>
        <LaneMask>0x18</LaneMask>
        <LaneAssign>0x3</LaneAssign>
        <ComboMode>1</ComboMode>
      </CSIInfo>
      <LensInfo>
        <FocalLength>4.73</FocalLength>
        <FNumber>2.2</FNumber>
        <TotalFocusDistance>1.9</TotalFocusDistance>
        <HorizontalViewAngle>64.1</HorizontalViewAngle>
        <VerticalViewAngle>51.6</VerticalViewAngle>
        <MinFocusDistance>0.1</MinFocusDistance>
      </LensInfo>
    </SensorNode>
  </StereoConfig>

<!-- IMX296 module in camera slot 0 -->
<!--
 <CameraModuleConfig>                                  
    <CameraId>0</CameraId>
    <SensorName>imx296</SensorName>
    <ChromatixName>ov7251_chromatix</ChromatixName>
    <ModesSupported>1</ModesSupported>
    <Position>BACK</Position>
    <MountAngle>360</MountAngle>
    <CSIInfo>
      <CSIDCore>0</CSIDCore>
      <LaneMask>0x1F</LaneMask>
      <LaneAssign>0x4320</LaneAssign>
      <ComboMode>0</ComboMode>
    </CSIInfo>
    <LensInfo>
      <FocalLength>4.73</FocalLength>
      <FNumber>2.2</FNumber>
      <TotalFocusDistance>1.9</TotalFocusDistance>
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>
      <MinFocusDistance>0.1</MinFocusDistance>
    </LensInfo>
  </CameraModuleConfig>
-->

  <!-- IMX412 in camera slot 0 -->
  <CameraModuleConfig>
    <CameraId>0</CameraId>
    <SensorName>imx412</SensorName>
    <ChromatixName>imx412_chromatix</ChromatixName>
    <ModesSupported>1</ModesSupported>
    <Position>BACK</Position>
    <MountAngle>360</MountAngle>
    <CSIInfo>
      <CSIDCore>0</CSIDCore>
      <LaneMask>0x1F</LaneMask>
      <LaneAssign>0x4320</LaneAssign>
      <ComboMode>0</ComboMode>
    </CSIInfo>
    <LensInfo>
      <FocalLength>2.73</FocalLength>
      <FNumber>3.2</FNumber>
      <TotalFocusDistance>1.9</TotalFocusDistance>
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>
      <MinFocusDistance>0.1</MinFocusDistance>
    </LensInfo>
  </CameraModuleConfig>

  <!-- IMX412 in camera slot 1 -->                                
  <CameraModuleConfig>                                   
    <CameraId>1</CameraId>                                              
    <SensorName>imx412</SensorName>                      
    <ChromatixName>imx412_chromatix</ChromatixName>      
    <ModesSupported>1</ModesSupported>                                         
    <Position>BACK</Position>                                                   
    <MountAngle>360</MountAngle>                                                
    <CSIInfo>                                                                    
      <CSIDCore>1</CSIDCore>                                                      
      <LaneMask>0x1F</LaneMask>                          
      <LaneAssign>0x4320</LaneAssign>                    
      <ComboMode>0</ComboMode>                                               
    </CSIInfo>                                           
    <LensInfo>                                                                  
      <FocalLength>2.73</FocalLength>                                             
      <FNumber>3.2</FNumber>                                                    
      <TotalFocusDistance>1.9</TotalFocusDistance>                              
      <HorizontalViewAngle>64.1</HorizontalViewAngle>                           
      <VerticalViewAngle>51.6</VerticalViewAngle>                               
      <MinFocusDistance>0.1</MinFocusDistance>                                  
    </LensInfo>                                                                 
  </CameraModuleConfig> 

  <!-- IMX412 in camera slot 1 using alternate I2C address, configured in HW -->
  <CameraModuleConfig>
    <CameraId>1</CameraId>
    <SensorName>imx412</SensorName>
    <SensorSlaveAddress>0x20</SensorSlaveAddress>
    <ChromatixName>imx412_chromatix</ChromatixName>
    <ModesSupported>1</ModesSupported>
    <Position>BACK</Position>
    <MountAngle>360</MountAngle>
    <CSIInfo>
      <CSIDCore>1</CSIDCore>
      <LaneMask>0x1F</LaneMask>
      <LaneAssign>0x4320</LaneAssign>
      <ComboMode>0</ComboMode>
    </CSIInfo>
    <LensInfo>
      <FocalLength>2.73</FocalLength>
      <FNumber>3.2</FNumber>
      <TotalFocusDistance>1.9</TotalFocusDistance>
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>
      <MinFocusDistance>0.1</MinFocusDistance>
    </LensInfo>
  </CameraModuleConfig>

  <!-- IMX230 in camera slot 0 -->                                
  <CameraModuleConfig>                                  
    <CameraId>0</CameraId>                                              
    <SensorName>imx230</SensorName>
    <ActuatorName>lc898212xd</ActuatorName>         
    <EepromName>onsemi_cat24c32</EepromName>                                   
    <FlashName>pmic</FlashName>                                                 
    <ChromatixName>imx230_chromatix</ChromatixName>                             
    <I2CFrequencyMode>FAST</I2CFrequencyMode>                                    
    <ModesSupported>1</ModesSupported>                                            
    <Position>BACK</Position>
    <MountAngle>360</MountAngle>                 
    <CSIInfo>                                                                
      <CSIDCore>0</CSIDCore>
      <LaneMask>0x1F</LaneMask>         
      <LaneAssign>0x4320</LaneAssign>                                             
      <ComboMode>0</ComboMode>                             
    </CSIInfo>                                           
    <LensInfo>                                                                 
      <FocalLength>4.73</FocalLength>                                       
      <FNumber>2.2</FNumber>                           
      <TotalFocusDistance>1.9</TotalFocusDistance>
      <HorizontalViewAngle>64.1</HorizontalViewAngle>
      <VerticalViewAngle>51.6</VerticalViewAngle>                        
      <MinFocusDistance>0.1</MinFocusDistance>                  
    </LensInfo>
  </CameraModuleConfig> 

</CameraConfigurationRoot>
